﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kompozyt
{
    internal class IteratorPodwładnych : IEnumerator<Pracownik>
    {
        private int indeksBieżącegoElementu = -1;
        private List<Pracownik> lista;

        public IteratorPodwładnych(Kierownik kierownik)
        {
            this.lista = kierownik.ToList();
        }

        public Pracownik Current
        {
            get
            {
                return lista[indeksBieżącegoElementu];
            }
        }        

        object IEnumerator.Current => Current;

        public void Dispose()
        {
            //nic takie nie robimy
        }

        public bool MoveNext()
        {
            indeksBieżącegoElementu++;
            return indeksBieżącegoElementu < lista.Count;
        }

        public void Reset()
        {
            indeksBieżącegoElementu = 0;
        }
    }
}
